import { Component, OnInit, Input } from '@angular/core';
import { NgbActiveModal } from '@ng-bootstrap/ng-bootstrap';
import { BackendService, ScrumUserstory, Priority } from '../services/backend.service';

@Component({
	selector: 'app-userstory-form',
	templateUrl: './userstory-form.component.html',
	styleUrls: [ './userstory-form.component.css' ]
})
export class UserstoryFormComponent implements OnInit {
	@Input() public userstory: ScrumUserstory;
	private editing: boolean;

	constructor(private backendService: BackendService, private activeModalService: NgbActiveModal) {}

	ngOnInit(): void {
		if (this.userstory === null || this.userstory === undefined) {
			this.userstory = { title: '' };
			this.editing = false;
		} else {
			this.editing = true;
		}
		document.getElementById('titleField').focus();
	}

	onSubmit() {
		if (this.editing) {
			this.backendService.putUserstory(this.userstory).subscribe((response) => {
				if (response.status > 399) {
					alert('Fehler');
				}
			});
		} else {
			this.backendService.postUserstory(this.userstory).subscribe((response) => {
				if (response.status > 399) {
					alert('Fehler');
				}
			});
		}
		this.activeModalService.close(this.userstory);
	}
	onClose() {
		this.activeModalService.dismiss(this.userstory);
	}

	//focusTitleField() {
	//	document.getElementById('titleField').focus();
	//}
}
